aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorQuentin <quentin@deuxfleurs.fr>2020-11-29 17:19:55 +0100
committerQuentin <quentin@deuxfleurs.fr>2020-11-29 17:19:55 +0100
commit15f409d4044471992609d0cbf9e430b22c9e08a9 (patch)
tree9be34e8fba3905567fcf1324115c0b1cd4558d09
parentaa320aa04ad2e3d3283b776f17444000dbec9b43 (diff)
parentcee6c3a821fb2ef0f5254f9ad1c0e47dd47047d4 (diff)
downloadgarage-15f409d4044471992609d0cbf9e430b22c9e08a9.tar.gz
garage-15f409d4044471992609d0cbf9e430b22c9e08a9.zip
Merge branch 'master' into feature/website
-rwxr-xr-xscript/dev-clean.sh7
-rwxr-xr-xscript/dev-configure.sh5
-rwxr-xr-xscript/dev-env.sh1
-rwxr-xr-xscript/test-smoke.sh22
-rw-r--r--src/api/s3_put.rs22
5 files changed, 44 insertions, 13 deletions
diff --git a/script/dev-clean.sh b/script/dev-clean.sh
new file mode 100755
index 00000000..151c5547
--- /dev/null
+++ b/script/dev-clean.sh
@@ -0,0 +1,7 @@
+#!/bin/bash
+
+set -ex
+
+killall -9 garage || echo "garage is not running"
+rm -rf /tmp/garage*
+rm -rf /tmp/config.*.toml
diff --git a/script/dev-configure.sh b/script/dev-configure.sh
index 8b7392c6..698c7ed9 100755
--- a/script/dev-configure.sh
+++ b/script/dev-configure.sh
@@ -6,6 +6,11 @@ GARAGE_DEBUG="${REPO_FOLDER}/target/debug/"
GARAGE_RELEASE="${REPO_FOLDER}/target/release/"
PATH="${GARAGE_DEBUG}:${GARAGE_RELEASE}:$PATH"
+until garage status 2>&1|grep -q Healthy ; do
+ echo "cluster starting..."
+ sleep 1
+done
+
garage status \
| grep UNCONFIGURED \
| grep -Po '^[0-9a-f]+' \
diff --git a/script/dev-env.sh b/script/dev-env.sh
index 61c8618f..a2829c73 100755
--- a/script/dev-env.sh
+++ b/script/dev-env.sh
@@ -12,4 +12,3 @@ export AWS_DEFAULT_REGION='garage'
alias s3grg="aws s3 \
--endpoint-url http://127.0.0.1:3900"
-
diff --git a/script/test-smoke.sh b/script/test-smoke.sh
new file mode 100755
index 00000000..7b462b00
--- /dev/null
+++ b/script/test-smoke.sh
@@ -0,0 +1,22 @@
+#!/bin/bash
+
+set -ex
+shopt -s expand_aliases
+
+SCRIPT_FOLDER="`dirname \"$0\"`"
+REPO_FOLDER="${SCRIPT_FOLDER}/../"
+
+cargo build
+${SCRIPT_FOLDER}/dev-clean.sh
+${SCRIPT_FOLDER}/dev-cluster.sh > /tmp/garage.log 2>&1 &
+${SCRIPT_FOLDER}/dev-configure.sh
+${SCRIPT_FOLDER}/dev-bucket.sh
+source ${SCRIPT_FOLDER}/dev-env.sh
+
+dd if=/dev/urandom of=/tmp/garage.rnd bs=1M count=10
+
+s3grg put /tmp/garage.rnd s3://eprouvette/
+s3grg ls s3://eprouvette
+s3grg get s3://eprouvette/garage.rnd /tmp/garage.dl
+
+diff /tmp/garage.rnd /tmp/garage.dl
diff --git a/src/api/s3_put.rs b/src/api/s3_put.rs
index a528720d..9c4d625c 100644
--- a/src/api/s3_put.rs
+++ b/src/api/s3_put.rs
@@ -51,12 +51,7 @@ pub async fn handle_put(
let md5sum_arr = md5sum.finalize();
let md5sum_hex = hex::encode(md5sum_arr);
- let mut sha256sum = Sha256::new();
- sha256sum.input(&first_block[..]);
- let sha256sum_arr = sha256sum.result();
- let mut hash = [0u8; 32];
- hash.copy_from_slice(&sha256sum_arr[..]);
- let sha256sum_hash = Hash::from(hash);
+ let sha256sum_hash = hash(&first_block[..]);
ensure_checksum_matches(
md5sum_arr.as_slice(),
@@ -253,7 +248,7 @@ impl BodyChunker {
body,
read_all: false,
block_size,
- buf: VecDeque::new(),
+ buf: VecDeque::with_capacity(2 * block_size),
}
}
async fn next(&mut self) -> Result<Option<Vec<u8>>, GarageError> {
@@ -278,11 +273,10 @@ impl BodyChunker {
}
}
-pub fn put_response(version_uuid: UUID, etag: String) -> Response<Body> {
+pub fn put_response(version_uuid: UUID, md5sum_hex: String) -> Response<Body> {
Response::builder()
.header("x-amz-version-id", hex::encode(version_uuid))
- .header("ETag", etag)
- // TODO ETag
+ .header("ETag", format!("\"{}\"", md5sum_hex))
.body(Body::from(vec![]))
.unwrap()
}
@@ -369,7 +363,7 @@ pub async fn handle_put_part(
}
// Copy block to store
- let version = Version::new(version_uuid, bucket.into(), key.into(), false, vec![]);
+ let version = Version::new(version_uuid, bucket, key, false, vec![]);
let first_block_hash = hash(&first_block[..]);
let (_, md5sum_arr, sha256sum) = read_and_put_blocks(
&garage,
@@ -388,7 +382,11 @@ pub async fn handle_put_part(
content_sha256,
)?;
- Ok(Response::new(Body::from(vec![])))
+ let response = Response::builder()
+ .header("ETag", format!("\"{}\"", hex::encode(md5sum_arr)))
+ .body(Body::from(vec![]))
+ .unwrap();
+ Ok(response)
}
pub async fn handle_complete_multipart_upload(